﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Imports Microsoft.Xna.Framework.Audio
Imports Microsoft.Xna.Framework.Content
Imports Microsoft.Xna.Framework.Media
Imports Microsoft.Xna.Framework.Input
Imports Microsoft.Xna.Framework.GamerServices

Public Class Game
    Inherits Microsoft.Xna.Framework.Game
    'Fields in our game graphic manager etc'
    Dim graphics As GraphicsDeviceManager
    Dim spriteBatch As SpriteBatch

    '
    'Texture that we will render
    Private mTexture1 As Texture2D
    Private mTexture2 As Texture2D
    'Set the coordinates to draw the sprite at
    Private spritePos As Vector2 = Vector2.Zero
    Private spritePos2 As Vector2 = Vector2.Zero
    'X and Y speed of the sprites
    Private XSpeed As Single = 80
    Private YSpeed As Single = 120
    'Vector2 used for the speed of the sprites
    Private spriteSpeed As New Vector2(XSpeed + 25, YSpeed + 25)
    Private spriteSpeed2 As New Vector2(XSpeed + 125, YSpeed + 125)
    'sound
    Private mysound As SoundEffect
    'background
    Private backgroundTexture As Texture2D

    Public Sub New()
        graphics = New GraphicsDeviceManager(Me)
        'graphics.ToggleFullScreen()
        Window.Title = "Test"
        graphics.PreferredBackBufferHeight = 600
        graphics.PreferredBackBufferWidth = 800
    End Sub

    Protected Overrides Sub Initialize()
        'TODO: Add your initialization logic here'
        MyBase.Initialize()
    End Sub
    Protected Overrides Sub LoadContent()
        ' TODO: use this.Content to load your game content here'
        MyBase.LoadContent()
        ' Create a new SpriteBatch, which can be used to draw textures.'
        spriteBatch = New SpriteBatch(GraphicsDevice)

        'Load (compiled) textures
        mTexture1 = Content.Load(Of Texture2D)("bille_bleue1")
        mTexture2 = Content.Load(Of Texture2D)("bille_rouge1")
        'load (compiled) sound
        mysound = Content.Load(Of SoundEffect)("sleep")
        'load (compiled) background
        backgroundTexture = Content.Load(Of Texture2D)("background")

    End Sub
    Protected Overrides Sub UnloadContent()
        MyBase.UnloadContent()
        'TODO: Unload any non ContentManager content here'
    End Sub
    Protected Overrides Sub Update(ByVal gameTime As Microsoft.Xna.Framework.GameTime)
        'Allows the game to exit'
        If GamePad.GetState(PlayerIndex.One).Buttons.Back = ButtonState.Pressed Then
            Me.Exit()
        End If
        'TODO: Add your update logic here'

        'The method that will update our sprite position'
        UpdateSprite2(gameTime)
        UpdateSprite(gameTime)
        detect_collision()

        MyBase.Update(gameTime)

    End Sub
    Protected Overrides Sub Draw(ByVal gameTime As Microsoft.Xna.Framework.GameTime)
        GraphicsDevice.Clear(Color.CornflowerBlue)
        'TODO: Add your drawing code here'

        'Draw the sprite'
        spriteBatch.Begin(SpriteSortMode.BackToFront, BlendState.AlphaBlend)
        spriteBatch.Draw(backgroundTexture, New Rectangle(0, 0, GraphicsDevice.Viewport.Width, GraphicsDevice.Viewport.Height), Color.White)
        spriteBatch.Draw(mTexture1, spritePos, Color.White)
        spriteBatch.Draw(mTexture2, spritePos2, Color.White)
        spriteBatch.End()


        'TODO: Add your drawing code here'
        MyBase.Draw(gameTime)
    End Sub
    Private Sub detect_collision()
        Dim rec1 As Rectangle = New Rectangle(spritePos.X, spritePos.Y, mTexture1.Width, mTexture1.Height)
        Dim bitsA(mTexture1.Height * mTexture1.Width - 1) As Color
        mTexture1.GetData(Of Color)(bitsA)


        Dim rec2 As Rectangle = New Rectangle(spritePos2.X, spritePos2.Y, mTexture2.Width, mTexture2.Height)
        Dim bitsb(mTexture2.Height * mTexture2.Width - 1) As Color
        mTexture2.GetData(Of Color)(bitsb)

        'avec gestion des pixels transparents
        If IntersectPixels(rec1, bitsA, rec2, bitsb) = True Then mysound.Play()

        'fonctionne mais sans gestion des pixels transparents
        'If rec1.Intersects(rec2) Then
        'mysound.Play()
        'End If

    End Sub


    Private Sub UpdateSprite(ByVal gameTime As GameTime)
        'The function move the sprite and check if its on the limits of the screen so it can bounce back'
        Dim intMaxX As Integer
        Dim intMinX As Integer = 0
        Dim intMaxY As Integer
        Dim intMinY As Integer = 0

        'move the sprite by speed scaled by elapsed time'
        spritePos += spriteSpeed * CSng(gameTime.ElapsedGameTime.TotalSeconds)
        'Get the max. X and Y coordinates'
        intMaxX = graphics.GraphicsDevice.Viewport.Width - mTexture1.Width
        intMaxY = graphics.GraphicsDevice.Viewport.Height - mTexture1.Height
        'Check the sprite if its at some of the edges of the screen and then reverce the speed of the sprite'
        If spritePos.X > intMaxX Then
            'Check if the sprite is at the maximum X coordinates of the screen if so reverse the speed'
            spriteSpeed.X *= -1
            spritePos.X = intMaxX
            mysound.Play()

        ElseIf spritePos.X < intMinX Then
            'Check if the sprite is at the minimum X coordinates of the scree and reverse the speed'
            spriteSpeed.X *= -1
            spritePos.X = intMinX
            mysound.Play()
        End If

        If spritePos.Y > intMaxY Then
            'Check if the sprite is at the maximum Y coordinates of the screen if so reverse the speed'
            spriteSpeed.Y *= -1
            spritePos.Y = intMaxY
            mysound.Play()

        ElseIf spritePos.Y < intMinY Then
            'Check if the sprite is at the minimum Y coordinates of the scree and reverse the speed'
            spriteSpeed.Y *= -1
            spritePos.Y = intMinY
            mysound.Play()
        End If

    End Sub

    Private Sub UpdateSprite2(ByVal gameTime As GameTime)
        'The function move the sprite and check if its on the limits of the screen so it can bounce back'
        Dim intMaxX As Integer
        Dim intMinX As Integer = 0
        Dim intMaxY As Integer
        Dim intMinY As Integer = 0

        'move the sprite by speed scaled by elapsed time'
        spritePos2 += spriteSpeed2 * CSng(gameTime.ElapsedGameTime.TotalSeconds)
        'Get the max. X and Y coordinates'
        intMaxX = graphics.GraphicsDevice.Viewport.Width - mTexture2.Width
        intMaxY = graphics.GraphicsDevice.Viewport.Height - mTexture2.Height
        'Check the sprite if its at some of the edges of the screen and then reverce the speed of the sprite'
        If spritePos2.X > intMaxX Then
            'Check if the sprite is at the maximum X coordinates of the screen if so reverse the speed'
            spriteSpeed2.X *= -1
            spritePos2.X = intMaxX
            mysound.Play()

        ElseIf spritePos2.X < intMinX Then
            'Check if the sprite is at the minimum X coordinates of the scree and reverse the speed'
            spriteSpeed2.X *= -1
            spritePos2.X = intMinX
            mysound.Play()
        End If

        If spritePos2.Y > intMaxY Then
            'Check if the sprite is at the maximum Y coordinates of the screen if so reverse the speed'
            spriteSpeed2.Y *= -1
            spritePos2.Y = intMaxY
            mysound.Play()

        ElseIf spritePos2.Y < intMinY Then
            'Check if the sprite is at the minimum Y coordinates of the scree and reverse the speed'
            spriteSpeed2.Y *= -1
            spritePos2.Y = intMinY
            mysound.Play()
        End If

    End Sub

    '/// <summary>
    '    /// Determines if there is overlap of the non-transparent pixels
    '    /// between two sprites.
    '    /// </summary>
    '    /// <param name="rectangleA">Bounding rectangle of the first sprite</param>
    '    /// <param name="dataA">Pixel data of the first sprite</param>
    '    /// <param name="rectangleB">Bouding rectangle of the second sprite</param>
    '    /// <param name="dataB">Pixel data of the second sprite</param>
    '    /// <returns>True if non-transparent pixels overlap; false otherwise</returns>
    Private Function IntersectPixels(rectangleA As Rectangle, dataA() As Color,
                                     rectangleB As Rectangle, dataB() As Color) As Boolean

        '/ Find the bounds of the rectangle intersection
        Dim top As Integer = Math.Max(rectangleA.Top, rectangleB.Top)
        Dim bottom As Integer = Math.Min(rectangleA.Bottom, rectangleB.Bottom)
        Dim Left As Integer = Math.Max(rectangleA.Left, rectangleB.Left)
        Dim Right As Integer = Math.Min(rectangleA.Right, rectangleB.Right)

        Dim pointa As Integer
        Dim pointb As Integer

        '// Check every point within the intersection bounds
        Dim y As Integer
        Dim x As Integer
        For y = top To bottom
            For x = Left To Right

                pointa = (x - rectangleA.Left) + (y - rectangleA.Top) * rectangleA.Width
                If pointa >= dataA.Count Then pointa = dataA.Count - 1
                pointb = (x - rectangleB.Left) + (y - rectangleB.Top) * rectangleB.Width
                If pointb >= dataB.Count Then pointb = dataB.Count - 1
                '// Get the color of both pixels at this point
                Dim colorA As Color = dataA(pointa)
                Dim colorB As Color = dataB(pointb)

                '// If both pixels are not completely transparent,
                If (colorA.A <> 0 And colorB.A <> 0) Then
                    '// then an intersection has been found
                    IntersectPixels = True
                    Exit Function
                End If
            Next x
        Next y

        '// No intersection found
        IntersectPixels = False
    End Function

End Class

